/* This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

/* Shell - added piping / redirection / history / internal commands / enviroment variables */


#include<stdio.h>
#include<unistd.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#define MAXSIZE 100 /* Max no of history commands */

char **history ; // 2 dimensional array to carry the history of the commands 
int main_pid;
int history_tos=0; // history top of stack

/* internal commands layer */
int inter(char ***com);

/* parser layer */
char * subparser (char * line);
char * subparser2 (char *line);
char *** parse(char * line,int *omode  ,  int *ncount , int * filename);	
char * layer1parser(char *line);


/* here the history will implement a stack procedure 
so that first in will be the last out */
char *  history_get (int history_no);
void history_add(char * command );
void display_history (void);

/* enviroment variables functions */
int envn(int mod,char *var,char *val);//mod can be 0: set var with val or 1: get val of var 
char *evm(char *str);//str can be $var to get its data or x=value to set var x with the value
int evf(int mod);//mod = 0 to save all variables to a file or mod = 1 to load from the file 

/*Core layer */
int core (char ***arg,int count ,int opmode, char *fname );


char env[100][100];
int count=0;


int main (void)

{
char ***tmpar;
char ***ret;
int mainpid;
char ***ret2;
char ***ret3;
char *line ;
char *line2;
int flag;
int pid,pid2;
int cnum ;
int omode;
int fname = 0;
// temp array to carry the clear command 
tmpar = (char ***) malloc ( sizeof(char**));
tmpar[0] = (char **) malloc ( 2 * sizeof(char*));
tmpar[0][0] = (char *) malloc ( 8 * sizeof(char));
tmpar[0][1]=NULL;


history = (char ** ) malloc ( MAXSIZE * sizeof (char *));
line2 = (char *) malloc (100 * sizeof (char));
fflush(stdout);
printf("\033[1;32;40m");
fflush(stdout);
strcpy(tmpar[0][0],"clear");
core(tmpar,1,1,NULL);
//execlp("clear",NULL);
while (1)
{
printf ("Fadsh# ");
gets(line2);
mainpid = getppid();
main_pid=mainpid;
if (strlen(line2) != 0)
{
//printf("line = %s",line);

   if (! evm(line2))
	{
	
	//printf("i'm in !!!!!");	
	line=layer1parser(line2);
	ret = parse ( subparser(line),&omode,&cnum,&fname);
	//printf ("\n mode = %d , num = %d ",omode,cnum);
	history_add(line);


	flag=inter(ret);

		if ( flag && omode == 3  )
		{
		core(ret,cnum,omode,ret[1][fname]);
		}

		else if ( flag )

		{
		pid=fork();
			if (!pid)
			{
			core(ret,cnum,omode,NULL);
			}
			else
			{
			wait(0);
			}

		}	

	}
	else 
	{
	
			
	}		
}


}


return 0;

}



int core (char ***arg,int count ,int opmode, char *fname )
{
// *** arg is the 3 dimensional array carrying the commands and all their arguments
// count is the count of sent commands
// opmode is the operation mode weather 1,2,3
// 1 means single command
// 2 means pipelined commands
// 3 means redirection
// fname carries the redirection file name , and is NULL in case of opmodes 1,2
int  pipeid[2];
int cpid,pid,i,pid2;
int fd;
int errlog;
switch (opmode)
{



case 1:
//	printf("count = %d  opmode = %d",count,opmode);
//	printf("i'm in case 1 ");
//	printf("count = %d",count);
	
	for (i=0;i<count;i++)
	{
	
	cpid=fork();
	
	if (!cpid)
	{
	errlog =execvp(arg[i][0],arg[i]);
	if (errlog == -1 )
	{
	perror ("Error");
	}
	}
	else
	{	
			wait(0);
		//exit(0);	


	}

	
	
	}

break;
	

case 2:
	

	/* the first parent field */
	/*close its stdout and open the first pipe end */
	pipe(pipeid);
	//perror ("Pipe no 1");
	/*Here the O/P goes on the pipe end no 0 */
	//printf ("pipes %d , %d",pipeid[0],pipeid[1]);
	pid=fork();			
	//printf ("\n pid = %d",pid);
	/* child part starts here */
	if (!pid) 

	{
	printf ("\n in child");
	close(1);
	dup(pipeid[0]);
	close (pipeid[1]);
	//printf ("\n  pipe 1");
	errlog=	execvp(arg[0][0],arg[0]);
	if (errlog = -1 )
	{
	perror ("Error");
	break;
	}

	}

	else 
	{
	//write (1,"welcome",8);
	//printf ("\nwelcome2");
		
		
		
	close(0);
	dup(pipeid[1]);
	close (pipeid[0]);
	//printf ("\n  pipe 2 \n");
	 execvp(arg[1][0],arg[1]);
	

	
	
	
	}	
	

break;



case 3: /* Redirection Of output */
//printf ("\nfile is %s" ,fname);
/* The only supported thing is the > */
fd=open (fname,O_CREAT|O_WRONLY,0666);

if (fd == -1)
{

perror ("Error");

}
//perror("fopen");

if ( fd != -1 ) 

{
pid = fork() ;
if (!pid)
{
close(1);
dup(fd);
execvp(arg[0][0],arg[0]);
}

}
break;
}

return 0;
}





void history_add(char * command )
{
	int i;
	//check if the history stack is full
	if ( history_tos == MAXSIZE )
	{
	
	// HERE we should free the first command in the history ,and shift all the others 

		for ( i=0 ; i<MAXSIZE-1 ; i++)
		{	
		strcpy (history[i],history[i+1]);
		}	
	
	//now shifting is done , we should put the command in the last element of the array//
	free (history [99]);
	history[99] = (char * ) malloc ( strlen (command ) * sizeof (char));
	strcpy (history[99],command);
	}

	// else the history stack is not full
	
	else 
	{	
	history[history_tos]=(char *) malloc ( strlen(command) * sizeof (char) );
	strcpy (history[history_tos],command);
	history_tos++;
	}



}



char *  history_get (int history_no)
{	// history number carries the number of the command in the history
	// numbering starts from 0 , so -1 is sent if needed to execute the 	
	// last command only

	// first check if the tos == 0 ( no command in the history))

	if ( history_tos == 0)
	{

	return;

	}

	else 
	{

		if (history_no == -1)
		{
		return history[history_tos-1];
		}

		else
		{
		return history[history_no];
		}



	}


}



void display_history (void)

{

int i ;
	//printf ("history_tos = %d \n ",history_tos);
	for ( i = 0; i< history_tos ; i++)	
	{

	printf (" %d  %s \n",i,history[i]);

	}

//printf ("doneoneoneonedoneonfneofne");
}






char *** parse(char * line, int *omode ,int *ncount ,  int * filename)

{

int semi_num=0 ; // semicolumn counts
int red_num=0; // redirection counts
int pipe_num=0; // pipe counts
int i =0;
int j=0;
int s=0;
int arg_count=0;
int arg_len=0;
int flag=1;
char *line2;
int flag2 =0;
int x=0;
int a;

int *argc; // array to hold the number of argumetns of each command
char*** arg;
/* we will try to find the number of the ; and the | and the > in the line
if found we will handle them later , here we work character by character */
//printf ("\nhere2\n");
//printf ("\n strlen = %d ",strlen(line));
line2= (char*) malloc (strlen(line) * sizeof (char));

while ( i < strlen(line) )
{

	switch (line[i])
	{
		
	case ';' :
	semi_num++;
	break;

	case '[' :
	red_num++;
	break;
	
	case ']' :
	pipe_num++;
	break;


	}

i++;

}

//printf ("\n semi = %d , red_num = %d , piped = %d \n",semi_num,red_num,pipe_num);
/* now we have the number of occurnces of each of ; , > and ] 
next we do use these numbers to refill the ***args and the count */

/* first if there is a semicloumn */

if ( semi_num > 0)
{
	*ncount = semi_num ;
	*omode =1 ;
	argc = (int * ) malloc ( *ncount * sizeof (int));
	arg = (char *** ) malloc ( *ncount * sizeof(char **));
	i=0;
	arg_count=1;
	//printf (" ncount = %d ",*ncount);
	/* now we search for each of the semicloumn and spaces  */
	
// start by allocating a space for each argument of each command 

	for ( i=0 ; i < *ncount ; i++)
	{
		
			while ( j < strlen(line) )
			{
				//printf ("\nchar = %c  , j = %d ",line[j],j);
				switch (line[j] )
				{
				case ';' :
				flag = 0;
				j++;
				break;
				case ' ' :
				arg_count++;
				break;
				}
					if (!flag )
					{
					break;
					}

			j++;
			}		

	arg[i] = (char **) malloc ( (arg_count+1) * sizeof (char *));
	flag=1;
	argc[i] = arg_count;
	//printf ( "\n argc[%d] =%d" ,i,argc [ i ]);
	arg_count=0;
	}



// now each command separated by the ; has an allocated space for its parameters;

	//printf ("\nline = %s ",line);
	x=0;
	arg_len=0;

for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
		
			if ( (line[j] ) == ';')
			{
			s=0;
			x=j+1;
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg_len++;
			}
	
			else 
			{

			//printf ("\n allocated for arg[%d][%d] : %d bytes\n ",i,s,arg_len+2);
			arg[i][s] = (char * ) malloc ( (arg_len+2) * sizeof (char));
			s++;			
			arg_len=0;
			}


		}

		
}

s=0;		
x=0;
a=0;

for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
		
			if ( (line[j] ) == ';')
			{
			//printf ("\n found it1");	
			x=j+2;
			
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg[i][s][a] = line[j] ;
			//printf ("\n i=%d , s =%d , a=%d ,%c ",i,s,a,arg[i][s][a]);
			
			a++;
	
			}
	
			else 
			{
			//printf ("\n found it");	
			arg[i][s][a]='\0';
			//printf ("\n arg[%d][%d] = %s ",i,s, arg[i][s]);
			//printf ("\n found it");	
			s++;
			a=0;
			}


		}


arg[i][s]=NULL;
s=0;
a=0;

		
}

}
// here starts the parsing of the piping 
if (pipe_num > 0)
{
	
	*ncount = pipe_num ;
	*omode =2 ;
	argc = (int * ) malloc ( *ncount * sizeof (int));
	arg = (char *** ) malloc ( *ncount * sizeof(char **));
	i=0;
	arg_count=1;
	//printf (" ncount = %d ",*ncount);
	/* now we search for each of the semicloumn and spaces  */
	
// start by allocating a space for each argument of each command 

	for ( i=0 ; i < *ncount ; i++)
	{
		
			while ( j < strlen(line) )
			{
				//printf ("\nchar = %c  , j = %d ",line[j],j);
				switch (line[j] )
				{
				case ']' :
				flag = 0;
				j++;
				break;
				case ' ' :
				arg_count++;
				break;
				}
					if (!flag )
					{
					break;
					}

			j++;
			}		

	arg[i] = (char **) malloc ( (arg_count+1) * sizeof (char *));
	flag=1;
	argc[i] = arg_count;
	//printf ( "\n argc[%d] =%d" ,i,argc [ i ]);
	arg_count=0;
	}



// now each command separated by the ; has an allocated space for its parameters;

	//printf ("\nline = %s ",line);
	x=0;
	arg_len=0;

for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
		
			if ( (line[j] ) == ']')
			{
			s=0;
			x=j+1;
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg_len++;
			}
	
			else 
			{

			//printf ("\n allocated for arg[%d][%d] : %d bytes\n ",i,s,arg_len+2);
			arg[i][s] = (char * ) malloc ( (arg_len+2) * sizeof (char));
			s++;			
			arg_len=0;
			}


		}

		
}

s=0;		
x=0;
a=0;

for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
		
			if ( (line[j] ) == ']')
			{
			//printf ("\n found it1");	
			x=j+2;
			
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg[i][s][a] = line[j] ;
			//printf ("\n i=%d , s =%d , a=%d ,%c ",i,s,a,arg[i][s][a]);
			
			a++;
	
			}
	
			else 
			{
			//printf ("\n found it");	
			arg[i][s][a]='\0';
			//printf ("\n arg[%d][%d] = %s ",i,s, arg[i][s]);
			//printf ("\n found it");	
			s++;
			a=0;
			}


		}


arg[i][s]=NULL;
s=0;
a=0;
	

	
	
}

}

// here starts the parsing of the redirection 
if (red_num > 0)
{
	
	*ncount = red_num ;
	*omode =3 ;
	argc = (int * ) malloc ( *ncount * sizeof (int));
	arg = (char *** ) malloc ( *ncount * sizeof(char **));
	i=0;
	arg_count=1;
	//printf (" ncount = %d ",*ncount);
	/* now we search for each of the semicloumn and spaces  */
	
// start by allocating a space for each argument of each command 

	for ( i=0 ; i < *ncount ; i++)
	{
		
			while ( j < strlen(line) )
			{
				//printf ("\nchar = %c  , j = %d ",line[j],j);
				switch (line[j] )
				{
				case '[' :
				flag = 0;
				j++;
				break;
				case ' ' :
				arg_count++;
				break;
				}
					if (!flag )
					{
					break;
					}

			j++;
			}		

	arg[i] = (char **) malloc ( (arg_count+1) * sizeof (char *));
	flag=1;
	argc[i] = arg_count;
	//printf ( "\n argc[%d] =%d" ,i,argc [ i ]);
	arg_count=0;
	}



// now each command separated by the ; has an allocated space for its parameters;

	//printf ("\nline = %s ",line);
	x=0;
	arg_len=0;

for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
		
			if ( (line[j] ) == '[')
			{
			s=0;
			x=j+1;
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg_len++;
			}
	
			else 
			{

		//	printf ("\n allocated for arg[%d][%d] : %d bytes\n ",i,s,arg_len+2);
			arg[i][s] = (char * ) malloc ( (arg_len+2) * sizeof (char));
			s++;			
			arg_len=0;
			}


		}

		
}

s=0;		
x=0;
a=0;
//printf ("ncount = %d ",*ncount);
for ( i =0 ; i < *ncount ; i++)
	
{
		for ( j = x ; j< strlen(line);j++)
		{
			
			if ( (line[j] ) == '[')
			{
			//printf ("\n found it1");	
			x=j+2;
			
			break;
			}
	
			if ( (line[j] ) != ' ')
			{
			arg[i][s][a] = line[j] ;
			//printf ("\n i=%d , s =%d , a=%d ,%c ",i,s,a,arg[i][s][a]);
			
			a++;
	
			}
	
			else 
			{
			//printf ("\n found it");	
			arg[i][s][a]='\0';
			//printf ("\n arg[%d][%d] = %s ",i,s, arg[i][s]);
			*filename = s;
			//printf  ("file name is %d",filename);
			//printf ("\n found it");	
			s++;
			a=0;
			}


		}


arg[i][s]=NULL;
s=0;
a=0;
	

	
	
}

}

return arg;
}




char * subparser (char * line)
{
int i,j;
int flag=0; //flag to detect if there is space before or not 
char *newline ; // this variable will hold the data after modification to the line
newline=(char*) malloc ( strlen (line) * sizeof (char));

j=0;
for ( i =  0 ; i < strlen(line) ; i++)
{

	if (!flag)
	{

		switch (line[i])
	
		{
		
		case ' ':
		newline[j] = line[i];
		flag=1; 
		j++;
		break;

		default :
		newline[j] = line[i];
		//printf (" \n j= %d , %c ",j,newline[j]);
		flag=0;
		j++;
		break;

		}


	}

	else

	{
		switch (line[i])
		{

		case ' ' :
		break;
		default :
		flag=0;
		newline[j]=line[i];
		j++;

		break;


		}
		
	}



	



}
newline[j++]=' ';
newline[j++] = '\0';

return subparser2(newline);

}


char * subparser2 (char *line)
{
int i,j ;
char *newline;
newline = (char *) malloc (strlen(line ) * sizeof (char));
j=0;	
for  ( i =0; i < strlen(line) ; i++ )

{

	switch (line[i])

	{

	case ';':
		if ((line[i -1] == ' ') && (line [i +1] == ' '))
		{
		newline[j++]=line[i];
		break;
		}
	//printf ("\n char = %c  , j = %d",newline[j],j);
		if (line[i -1] != ' ')
		{
		newline[j] = ' ' ;	
		j++;
		}
	newline[j] = line[i];
	j++;
		if (line[i +1] != ' ')
		{
		newline[j] = ' ' ;
        	j++;
		}
	
	break;

	default :
	newline[j]=line[i];
	j++;
	break;
	
	

	}
		


}



return newline;


}

int inter(char ***com)
{
int f ;
char *c;
char ***ret;
int omode,cnum;
int fname;
//printf("%s %s",com[0][0],com[0][1]);	#################################################################
	
	if (!strcmp(com[0][0],"cd"))
	{
	if (com[0][1]!=NULL)
	chdir(com[0][1]);
	return 0;
	
	}
		else if (!strcmp(com[0][0],"exit")) 
		{
		printf("exit shell...\n");
		execlp ("/usr/bin/pkill","pkill","-9","fadsh",NULL);//####### edit finrev with the file name #########
	//	kill(main_pid,9);
		raise (9);
		exit(0);
		return 0;
		}
	
		else if (!strcmp(com[0][0],"history")) 
		{
			if (atoi(com[0][1]) != -1 )
			{
			c=history_get(atoi(com[0][1]));
			ret = parse ( subparser(c),&omode,&cnum,&fname);
//			printf ("\nomode = %d , cnum = %d " ,omode,cnum);	
				if (omode == 3 )
				{

				core(ret,cnum,omode,ret[1][fname]);
				}
				else 
				{
				core(ret,cnum,omode,NULL);
				}
			}
			else
			{
			display_history();
			}
		//call pre exit function
		return 0;
		}

		else if (!strcmp(com[0][0],"phistory")) 	

		{
		display_history();
		return 0;

 		}

		else if (!strcmp(com[0][0],"set")) 	

		{
		envn(2,NULL,NULL);

				return 0;

 		}

		else if (!strcmp(com[0][0],"echo")) 	

		{
		if (com[0][1]!=NULL)
		{
		printf ("\n%s ",com[0][1]);
		evm(com[0][1]);
		}
		else 
		{
		}
		return 0;
 		}



return -1;

}


char * layer1parser(char *line)
{

int i=0;                   /*counter points to char by char*/
int l;                     /*The length */                      
int flag=0;      /*flag if 1=;   if 2=[    if 3=]   */


l=strlen(line);
for(i=0;i<l;i++)                           /*while there is line*/
{
if(line[i] == ';') {flag = 1;}      
if(line[i] == '[') {flag = 2; }	
if(line[i] == ']') {flag = 3; }
	
}
	
	switch(flag)
	{	
	case 1:
	strcat ( line," ; " );
	break;
	case 2:
	strcat ( line," [ " );
	break;
	case 3:	
	strcat ( line," ] " );
	break;
	default:
        strcat ( line," ; " );
	}
//printf("the final result %s \n",line);
return line;
}



/* environment variables manager
i/p string can be "var=value" or $var
if "var=value" >>> call envn mod=0 set variable with the value
else if  "$var" >>>  call envn with get variable 
*/
char *evm(char *str)
{
char *st1,*st2,*st3,*s;
int c,len1,len2,len3;
//printf("starting evm....\n");

len1=strlen(str);

st1=(char *)malloc(10);
st2=(char *)malloc(10);
st3=(char *)malloc(10);
s=(char *)malloc(10);

strcpy(st1,str);
st2=strtok(st1,"$");
len2=strlen(st2);

strcpy(st1,str);
st3=strtok(st1,"=");
len3=strlen(st2);

if (len1>len2)
{int l;
//printf("getting variable %s...\n",st2);
l=strlen(st2);
//printf("length = %d\n",l);
if (l>1)
{
strcpy(st2,&st2[l-1]);
//printf("%s",st2);
}

if (count)
{
c=envn(1,st2,NULL);
//printf("%d",c);
       if (c!=-1)
          {
            strcpy(s,env[c]);
            s=strtok(s,"=");
            s=strtok(NULL,"=");
            //return s;
            printf ("%s\n",s);
          }
}
}
else if (len1>len3)
{
st1=strtok(NULL,"=");
//printf("setting variable %s with %s\n",st3,st1);
envn(0,st3,st1);
}
else 
return NULL;
}

/*environment variables files
i/p mod 0: save all env var to file, mod 1: load env var from that file
o/p return 0 no error return -1 an error occured 
*/
int evf(int mod)
{
 int i=0,j=0,fd,rtn;
 char str[100],chr;
  switch (mod)
  {

   case 0:
	fd=open("/tmp/~fadsh",O_CREAT | O_WRONLY, 0666);
	if (fd == -1)
	{return -1;}
	for(i=0;i<count;i++)
	{
	printf("writing %s\n",env[i]); 
	write(fd,env[i],100);
	write(fd,"\n",1);
	}
	close(fd);
   break;
   
   case 1:
	fd=open("/tmp/~fadsh",O_RDONLY,NULL);
	if (fd == -1)
	{return -1;}	
	rtn=read(fd,&chr,1);
	count=0;
	while(rtn>0)
	{
	if (chr=='\n')
	{count++;
//	printf("count = %d saved %s",count,env[i]);
	i++;j=0;printf("\n");}
	else 
	 {	
	   env[i][j]=chr;
//	   printf("%c",chr);
	   j++;
	 }
	
	rtn=read(fd,&chr,1);
	
	}
	close(fd);
   break;
  }
}


/*
environment variables
mod can be 0: set var with val or 1: get val of var 
var: string contains variable name to set or get 
val: string only if mod=1 contains val to be set in variable
*/
int envn(int mod,char *var,char *val)
{
int i=0,v=-1 ;
char *str,*s1,*s2,*s3,*s4;
char *tmpstr;
tmpstr=(char *)malloc(100);
//call init here
//s3=(char *)malloc(100);
//s4=(char *)malloc(100);


//printf("i'm in envn & mod = %d\n",mod);
switch (mod)
{

case 0: //set env var
    if (count > 0)	
	for (i=0;i<count;i++)
	{	strcpy(s1,env[i]);
		//printf("\n# i = %d # count = %d # env = %s # s1 = %s",i,count,env[i],s1);
		s2=strtok(s1,"=");
	 	//printf("\ns2 = %s",s2);
	 if (!strcmp(var,s2))	 
	   {
	 //    printf("\nthis variable is already existed\n");
	     
	     return 5;
	   }
	  else 
	   { 
	   }
	}	
	str=strcat(tmpstr,var);
	str=strcat(tmpstr,"=");
	str=strcat(tmpstr,val);
	strcpy(env[i],str); 
	//printf("\ndata> %s\n",env[i]);	
	count++;

	return 0;
break;
case 1:
//	printf("===> var sent is %s",var);
	for (i=0;i<count;i++)
	{char *t;
	int tt;
	 strcpy(tmpstr,env[i]);
	 t=strtok(tmpstr,"=");
	if (!strcmp(var,t))	 
	   {
//	    printf("i found it in %d as %s\n",i,env[i]);
	    
	     v=  i;
	     break;
	   }
	   else 
	   {
	   v=-1;
	   break;
	   }
	  
	}	
return v;
break;	
case 2:
       for(i=0;i<count;i++)
       {
       printf("%s\n",env[i]);
       }
}
return 0;
}
